%{

#include<stdlib.h>
#include<string.h>
#include <stdio.h>
#include <ctype.h>
#include <malloc.h>
#include "../h/func.h"
#include "../h/extern.h"
#include "makespec.h"

%}

%union{
    int token;
    char charv;
    char charp[200];
    PTR_BFND bf_node;
    PTR_LLND ll_node;
    PTR_SYMB symbol;
    PTR_TYPE data_type;
    PTR_HASH hash_entry;
    PTR_CMNT cmnt_node;
    PTR_LABEL label;
 } 

%token  FORMAT  ALLOCATE  DEALLOCATE  COMMON  NAMELIST CHARACTER  
%token  OPEN  READ WRITE  REWIND  BACKSPACE  ENDFILE  CLOSE INQUIRE  
%token  INTEGER  LOGICAL  COMPLEX IMPLICIT
%token  ACCESSL  ACTION  ADVANCE ALLOCATABLE ASSIGN  ASSIGNMENT  ASSOCIATED
%token  BLANK  BLOCKDATA  CALL  CASE 
%token  CONTAINS  CONTINUE  CYCLE  DATA  DEFAULTL
%token  DELIM  DIMENSION  DIRECT  DO  DOUBLEPRE
%token  ELSE  ELSEWHERE  ELSEIF  END 
%token  ENDDO  ENDIF  ENDSELECT  ENDWHERE  ENDTYPE  ENDBLOCKDATA
%token  ENDINTERFACE  ENDMODULE  ENDSUBROUTINE  ENDFUNCTION ENDPROGRAM
%token  ENTRY  EOR  EQUIVALENCE  ERR  EXIST  EXIT  EXTERNAL
%token  FILEI  FMT  FORALL FORM  FORMATTED  FUNCTION  GOTO IF  
%token  IN  INOUT  OUT  INTENT
%token  INTERFACE  INTRINSIC  IOLENGTH  IOSTAT
%token  KINDEQ  LENEQ  MODULE  NAMEI  NAMED  NEXTREC
%token  NML  NONE  NULLIFY  NUMBER  ONLY  OPENED  OPERATOR  OPTIONAL
%token  PAD  PARAMETER  PAUSE  POINTER  POSITION  PRINT  PRIVATE
%token  PROGRAM PROCEDURE  PUBLIC  READWRITE  REAL  REC  RECL
%token  RECURSIVE  RESULT  RETURN  SAVE  SELECTCASE  
%token  SEQUENCE  SEQUENTIAL  SIZE  STAT  STATUS  STOP  SUBROUTINE  
%token  TARGET  THEN  TO  TYPE  UNFORMATTED  UNIT  USE  WHERE  WHILE  
%token  INCLUDE

/*************************  Fortran D  ****************************/
%token  ALIGN  BLOCK CYCLIC DISTRIBUTE DYNAMIC EXTRINSIC HPF HPF_LOCAL
%token  INDEPENDENT INHERIT NEW NO ONTO PROCESSORS PURE REALIGN
%token  REDISTRIBUTE TEMPLATE WITH  
%token  DIRDIMENSION DIRSEQUENCE
/*****************************************************************/

%token  I  B  O  Z  F  E  EN  ES  G  L  A  D  P  T  TL  TR
%token  X  S  SP  SS  BN  BZ  H  

%token  COMMA1  COMMA2
%token  CARRIAGE  PERCENT  COMMA  FULLPOINT  SINGLEQUO  DOUBLEQUO
%token  LEFTBRACKET  RIGHTBRACKET  PLUS  MINUS  MULTIPLY  POWER  DIVIDE
%token  COLON  EQUAL  UNDERSCORE  DOUBLECOLON  FALSEL  TRUEL EQV
%token  NEQV  OR  AND  NOT  EQ  EQGT  NE  LT  LE  GT  GE  CONCAT
%token  LEFTBRACKET1  LEFTBRACKET2 GE1  GT1  LE1  LT1  NE1  EQ1
%token  QUESTION  HCHAR  ACVALUE1  ACVALUE2  UNDERSCORE1 

%token  FUNNAME LETTER DIGIT  STRING

%token  LABEL COMMENT 
%token  BINARY_CONST OCTAL_CONST HEX_CONST
%token  DEFINED_OPERATOR

%token  IDENTIFER
%token  DIGIT_STRING  KIND_PARAM  NAME
%token  INT_LITERAL_CONST   REAL_LITERAL_CONST   DOUBLE_LITERAL_CONST 
%token  LOGICAL_LITERAL_CONST
%token  SIGNIFICAND 

/****************    Fortran 90    ***************************/

%start executable_program
%type<bf_node> executable_program program_unit 
%type<bf_node> external_subprogram  module block_data  main_program
%type<bf_node> specification... executable...
%type<bf_node> internal_subprogram_part module_subprogram_part
%type<bf_node> internal_subprogram... internal_subprogram 
%type<bf_node> module_subprogram... module_subprogram
%type<bf_node> function_subprogram  subroutine_subprogram

%type<label>   label label1  opt_label
%type<ll_node> label_list

%type<bf_node> program_stmt end_program_stmt 
%type<bf_node> block_data_stmt end_block_data_stmt 
%type<bf_node> module_stmt end_module_stmt
%type<bf_node> function_stmt end_function_stmt 
%type<bf_node> subroutine_stmt end_subroutine_stmt
%type<cmnt_node> cmnt 
%type<bf_node> specification executable  
%type<bf_node> use_stmt 
%type<bf_node> parameter_stmt 
%type<bf_node> format_stmt 
%type<bf_node> implicit_stmt
%type<bf_node> common_stmt 
%type<bf_node> data_stmt 
%type<bf_node> dimension_stmt 
%type<bf_node> save_stmt 
%type<bf_node> equivalence_stmt
%type<bf_node> external_stmt 
%type<bf_node> intrinsic_stmt 
%type<bf_node> namelist_stmt 
%type<bf_node> intent_stmt 
%type<bf_node> access_stmt
%type<bf_node> optional_stmt 
%type<bf_node> pointer_stmt 
%type<bf_node> target_stmt 
%type<bf_node> allocatable_stmt
%type<bf_node> sequence_stmt 
%type<bf_node> entry_stmt
%type<bf_node> derived_type_stmt 
%type<bf_node> module_procedure_stmt 
%type<bf_node> interface_stmt
%type<bf_node> contains_stmt
%type<bf_node> type_declaration_stmt
%type<bf_node> assignment_stmt
%type<bf_node> backspace_stmt 
%type<bf_node> call_stmt 
%type<bf_node> close_stmt 
%type<bf_node> computed_goto_stmt 
%type<bf_node> continue_stmt 
%type<bf_node> open_stmt 
%type<bf_node> endfile_stmt 
%type<bf_node> forall_stmt
%type<bf_node> print_stmt 
%type<bf_node> read_stmt 
%type<bf_node> return_stmt 
%type<bf_node> rewind_stmt 
%type<bf_node> stop_stmt 
%type<bf_node> write_stmt
%type<bf_node> arithmetic_if_stmt 
%type<bf_node> pause_stmt
%type<bf_node> goto_stmt 
%type<bf_node> if_stmt 
%type<bf_node> where_stmt
%type<bf_node> inquire_stmt 
%type<bf_node> exit_stmt 
%type<bf_node> cycle_stmt
%type<bf_node> deallocate_stmt 
%type<bf_node> allocate_stmt 
%type<bf_node> nullify_stmt
%type<bf_node> associated_stmt 
%type<bf_node> assign_label_stmt 
%type<bf_node> assign_goto_stmt 
%type<bf_node> pointer_assignment_stmt
%type<bf_node> action_stmt 
%type<bf_node> case_construct 
%type<bf_node> do_construct 
%type<bf_node> where_construct 
%type<bf_node> if_construct
%type<bf_node> select_case_stmt case_stmt end_select_stmt 
%type<bf_node> nonlabel_do_stmt end_do_stmt label_do_stmt
%type<bf_node> end_if_stmt if_then_stmt else_if_stmt else_stmt
%type<bf_node> end_where_stmt elsewhere_stmt
%type<bf_node> block_do_construct nonblock_do_construct
%type<bf_node> outer_shared_do_construct
%type<bf_node> assignment_stmt...
%type<bf_node> module_procedure_stmt...


%type<bf_node> interface_block interface_body... interface_body 
%type<bf_node> end_interface_stmt
%type<bf_node> derived_type_def  private_sequence_stmt...
%type<bf_node> component_def_stmt...
%type<bf_node> component_def_stmt private_sequence_stmt 
%type<ll_node> component_attr_spec_list component_decl_list
%type<ll_node> component_attr_spec component_decl component_array_spec
%type<bf_node> end_type_stmt

%type<ll_node> implicit_spec letter_spec_list letter_spec 
%type<charv>    letter
%type<ll_node> rename_list  only_list  rename only
%type<ll_node> arglist 
%type<ll_node> generic_spec 
%type<ll_node> named_constant_def_list named_constant_def
%type<ll_node> comblock common_block_object
%type<ll_node> saved_entity_list  saved_entity
%type<ll_node> dims  array_spec
%type<ll_node> equivalence_set equivalence_object_list equivalence_object
%type<ll_node> intent_spec
%type<ll_node> access_spec access_id_list access_id
%type<ll_node> format_specification
%type<ll_node> format_item_list format_item 
%type<ll_node> r data_edit_desc control_edit_desc
%type<ll_node> char_string_edit_desc position_edit_desc w  
%type<ll_node> sign_edit_desc k blank_interp_edit_desc  n c 
%type<ll_node> rep_char1 
%type<data_type> type_spec 
%type<ll_node> newname1... entity_decl_list
%type<ll_node> attr_spec entity_decl 
%type<ll_node> length kind_selector char_selector length_selector
%type<ll_node> initialization_expr char_length type_param_value 
%type<ll_node> data_stmt_list
%type<ll_node> data_stmt_set data_stmt_object_list data_stmt_object
%type<ll_node> data_implied_do data_stmt_value 
%type<ll_node> data_stmt_constant data_stmt_repeat
%type<ll_node> data_stmt_value_list data_i_do_object_list data_i_do_object
%type<ll_node> data_i_do_variable 
%type<ll_node> procedure_name_list 

%type<ll_node> actual_arg_spec_list
%type<ll_node> actual_arg_spec actual_arg  
%type<ll_node> stat_variable allocation_list allocation allocate_object
%type<ll_node> allocate_shape_spec_list allocate_object_list  
%type<ll_node> allocate_shape_spec
%type<ll_node> allocate_lower_bound allocate_upper_bound
%type<ll_node> pointer_object_list pointer_object
%type<ll_node> target_pointer
%type<ll_node> stop_code char_constant
%type<ll_node> case_expr case_selector
%type<ll_node> case_value_range_list case_value_range case_value
%type<ll_node> do_variable 
%type<ll_node> int_initialization_expr 
%type<ll_node> loop_control numeric_expr logical_expr  mask_expr  
%type<bf_node> where_construct_begin
%type<ll_node> external_file_unit 
%type<ll_node> position_spec_list position_spec
%type<ll_node> close_spec_list  close_spec 
%type<ll_node> inquire_spec_list inquire_spec 
%type<ll_node> connect_spec_list connect_spec
%type<ll_node> file_name_expr default_char_expr
%type<ll_node> format output_item_list output_item
%type<ll_node> io_control_spec_list
%type<ll_node> input_item_list input_item 
%type<ll_node> io_implied_do 
%type<ll_node> io_implied_do_object_list io_implied_do_object 
%type<ll_node> io_implied_do_control
%type<ll_node> io_control_spec io_unit

%type<ll_node> opt_result opt_comma1 opt_double_colon  
%type<symbol>  progname blockname procname funcname  module_name  
%type<symbol>  name opt_name  /* hash_entry */
%type<symbol>  dummy_args dummy_arg  
%type<ll_node> prefix...  prefix  

%type<ll_node> digit_string  kind_param 
%type<ll_node> defined_operator intrinsic_operator

%type<ll_node> explicit_shape_spec_list explicit_shape_spec 
%type<ll_node> assumed_shape_spec_list assumed_size_spec assumed_shape_spec
%type<ll_node> lower_bound upper_bound 

%type<ll_node> expr
%type<ll_node> level_5_expr equiv_op equiv_operand 
%type<ll_node> or_op or_operand and_op and_operand not_op 
%type<ll_node> level_4_expr rel_op level_3_expr concat_op level_2_expr add_op 
%type<ll_node> add_operand mult_op mult_operand level_1_expr power_op 
%type<ll_node> primary  literal_constant 
%type<ll_node> array_constructor function_reference 
%type<ll_node> ac_value_list ac_value ac_implied_do ac_implied_do_control  
%type<ll_node> subobject1 array_section_element_funcref
%type<ll_node> structure_component substring data_ref substring_range
%type<ll_node> part_ref newname3 section_subscript_list
%type<ll_node> section_subscript subscript subscript_triplet 
%type<ll_node> constant
%type<ll_node> int_literal_constant real_literal_constant 
%type<ll_node> complex_literal_constant
%type<ll_node> real_part  image_part
%type<ll_node> logical_literal_constant char_literal_constant 
%type<ll_node> boz_literal_constant
%type<ll_node> double_literal_constant
%type<ll_node> signed_int_literal_constant signed_real_literal_constant 

/*********************   Fortran D   **************************/
%type<bf_node> hpf_spec_directives hpf_exec_directives 
%type<bf_node> forall_construct
%type<bf_node> processors_directive align_directive distribute_directive
%type<bf_node> dynamic_directive inherit_directive template_directive
%type<bf_node> combined_directive sequence_directive 
%type<bf_node> realign_directive redistribute_directive independent_directive

%type<ll_node> combined_attribute combined_attribute_list
%type<ll_node> dist_directive_stuff dist_attribute_stuff distributee
%type<ll_node> dist_format_clause dist_format_list dist_format
%type<ll_node> dist_onto_clause dist_target processors_name
%type<ll_node> align_directive_stuff align_attribute_stuff alignee 
%type<ll_node> alignee_list align_source align_dummy align_with_clause
%type<ll_node> align_spec align_target align_subscript_list align_subscript
%type<ll_node> alignee_distributee_list alignee_distributee
%type<ll_node> processors_decl_list processors_decl
%type<ll_node> template_decl_list template_decl template_name
%type<ll_node> association_name_list association_name new_clause variable_list

%type<bf_node> forall_construct_begin 
%type<bf_node> forall_body
%type<ll_node> forall_script_control forall_script_control_list
%type<ll_node> forall_control
%type<bf_node> forall_assignment
%type<ll_node> extrinsic_prefix extrinsic_kind_keyword

%%

executable_program       : program_unit
                         | executable_program  program_unit
				{ 
				  PTR_BFND p;
				  $$= setBfndList($1,$2); 
				  if(!(($1->variant==MODULE_STMT)||($1->variant==BLOCK_DATA)))
				  {
				  for(p=$1;p->entry.prog_stmt.next_prog;
					p=p->entry.prog_stmt.next_prog)
					;
				  p->entry.prog_stmt.next_prog=$2;
				  }
				}
                         ;

program_unit             : external_subprogram
                         | module
                         | block_data
			 | main_program
                         ;

main_program             : specification...
                           executable...
                           internal_subprogram_part
                           end_program_stmt
				{ 
				  $$ = makeMain_l(BFNULL,$1,$2,$3,$4);
				  }
                         | program_stmt cmnt
                           specification...
                           executable...
                           internal_subprogram_part
                           end_program_stmt
				{  
 				  $$ = makeMain_l($1,$3,$4,$5,$6); 
				}
                         ;

program_stmt: 		 PROGRAM progname 
			  {    
			    /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
			    $$ = makeProgram(fi,$2); 
			   }
			 ;

end_program_stmt:	 ENDPROGRAM opt_name cmnt
			  {   
			    /*if(resultFlag_g==1)strcat(pg[ln++],$$); */ 
			    $$ = makeEnd(fi);
			      }
			 | END cmnt
			  {   
			     /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
			    $$ = makeEnd(fi);}
			 ;	

specification...:	  { $$ = BFNULL; }
			 | specification... specification cmnt
				{ 
				if(debugFlag_g==1) printf("Specification...\n");
				$$ = setBfndList($1,$2); }
			 ;

executable...:		   { $$ = BFNULL; } 
			 | executable... opt_label executable  cmnt
				{
			 	if(debugFlag_g==1) printf("Executable...\n"); 
				 $$ = setBfndList($1,$3);
				}
			 ;

external_subprogram      : function_subprogram
                         | subroutine_subprogram
                         ;

function_subprogram      : function_stmt cmnt
                           specification...
                           executable...
                           internal_subprogram_part
                           end_function_stmt cmnt
				{ $$ = makeMain_l($1,$3,$4,$5,$6); 
				  }
                         ;

subroutine_subprogram    : subroutine_stmt cmnt
                           specification...
                           executable...
                           internal_subprogram_part
                           end_subroutine_stmt cmnt
				{ $$ = makeMain_l($1,$3,$4,$5,$6);
				  }
                         ;

module                   : module_stmt cmnt
                           specification...
                           module_subprogram_part
                           end_module_stmt cmnt
			    { 
			     $$ = makeMain_l($1,$3,BFNULL,$4,$5);
			     $1->entry.block_data.blockdata_end=$5;
			    }
                         ;

module_subprogram_part   : { $$ = BFNULL; }
                         | contains_stmt cmnt
                           module_subprogram...
                         ;

module_subprogram...     : module_subprogram
                         | module_subprogram... module_subprogram
			     {
				PTR_BFND p;
				$$= setBfndList($1,$2);
				for(p=$1;p->entry.prog_stmt.next_prog;
                                        p=p->entry.prog_stmt.next_prog)
                                        ;
                                  p->entry.prog_stmt.next_prog=$2;
				}	
                         ;

module_subprogram        : function_subprogram
                         | subroutine_subprogram
                         ;

module_stmt:		  MODULE name
			    {     
			      /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			      PTR_SYMB s;
			      s= makeSymbModule(fi,$2);
			      $$ = makeModule(fi,s);    }

			 ;

end_module_stmt:	  ENDMODULE opt_name
			   {    
			     /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			     $$ = makeEnd(fi);}
			 | END
		       	  {   
			    /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			    $$ = makeEnd(fi);}
			 ;

block_data               : block_data_stmt cmnt
                           specification...
                           end_block_data_stmt cmnt
				{
				  $$ = makeMain_l($1,$3,BFNULL,BFNULL,$4);
				  $1->entry.module_stmt.module_end=$4;
				 }
                         ;

block_data_stmt:	 BLOCKDATA blockname
				{  
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
				 $$ = makeBlock(fi,$2);}
			 ;

end_block_data_stmt:     ENDBLOCKDATA opt_name
			{    
			  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			  $$ = makeEnd(fi);}
			 | END 
			{   
			  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			  $$ = makeEnd(fi);}
			 ;

internal_subprogram_part : { $$ = BFNULL; }
                         | contains_stmt cmnt
                           internal_subprogram...
                         ;

internal_subprogram...   : internal_subprogram
                         | internal_subprogram... internal_subprogram
				{
				  PTR_BFND p;
				/*
				  $$ =  setBfndList($1,$2);
				*/
				  for(p=$1;p->entry.prog_stmt.next_prog;
                                        p=p->entry.prog_stmt.next_prog)
                                        ;
                                  p->entry.prog_stmt.next_prog=$2;
				  }
                         ;

internal_subprogram      : function_subprogram
                         | subroutine_subprogram
                         ;


cmnt:			  CARRIAGE
			    {  if(debugFlag_g==1) printf("cmnt :carriage\n");
			       $$ = CMNULL;
				  }
			 | COMMENT   { $$ = CMNULL;  } 
			 ;

function_stmt: 		 prefix... FUNCTION funcname arglist opt_result
                                 { 
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
  				  $$ = makeFunction(fi,$3,$4,$5,$1);
				 }
                         | FUNCTION funcname arglist opt_result
                                 { 
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				  $$ = makeFunction(fi,$2,$3,$4,LLNULL);
				}
			 ;

subroutine_stmt:	 SUBROUTINE procname arglist
				{   
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				  $$ = makeSubroutine(fi,$2,$3,LLNULL);
				}
                         | prefix... SUBROUTINE procname arglist
				{   
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				  $$ = makeSubroutine(fi,$3,$4,$1);
				}
			 ;

end_function_stmt:       ENDFUNCTION opt_name
			{  
			 /*if(resultFlag_g==1)  strcat(pg[ln++],$$); */
                         $$ = makeEnd(fi); }
			 | END 
			{   
			  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
  			 $$ =  makeEnd(fi);
			 }
			 ;

end_subroutine_stmt:     ENDSUBROUTINE opt_name
		 	{  
                         /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			 $$ = makeEnd(fi);
			 }
			 | END
			{   
			  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			  $$ = makeEnd(fi);  }
			 ;

progname		 :name
			    { $$ = makeSymbProg(fi,$1); }
		   	 ;   

blockname		 : { $$ = SMNULL ; }
			 | name
				{ $$ = makeSymbVar(fi,1,$1);
				   /* here "1" means the blockname is regarded
					as output_var temporarily. */
				   }
			 ;

procname 		 :name
				{ $$ = makeSymbProc(fi,$1);  }
			 ;

funcname 		 :name
				{ $$ = makeSymbFunc(fi,$1);  }
		 	 ;


arglist  		 : { $$ = LLNULL; }
			 | LEFTBRACKET RIGHTBRACKET
	                       { $$ = LLNULL; }
			 | LEFTBRACKET dummy_args  RIGHTBRACKET   
				{  }
			 ;

dummy_args               : dummy_arg
                         | dummy_args COMMA dummy_arg
                                {$$ = set_id_list($1, $3); }
                         ;

dummy_arg                : name  
                         | MULTIPLY   {  }
                         ;

opt_result:                {  } 
			 | RESULT LEFTBRACKET /*result_*/name RIGHTBRACKET 
                                 {
				    }
                         ;

opt_name:     		   { $$ = SMNULL;}
			 | name
			 ;

name:                     NAME
			   { if(debugFlag_g==1) printf("name: \n");
				$$ = makeSymb(fi,yytext);
				}
			 ;

prefix...:		   prefix
			 | prefix...  prefix
				{ $$=set_ll_list($1,$2,EXPR_LIST);  }
			 ;
 
/************* Grammar for specification        ****************/
/*************     1995 . 8 . 25            ********************/

specification:    	  implicit_stmt   
			 | use_stmt       
			 | entry_stmt
			 | interface_block
			 | parameter_stmt  
			 | derived_type_def
			 | type_declaration_stmt  
		         | common_stmt     
                         | data_stmt      
                         | dimension_stmt
                         | save_stmt       
                         | equivalence_stmt
                         | external_stmt   
                         | intrinsic_stmt  
                         | namelist_stmt  
                         | intent_stmt   
                         | access_stmt     /* it contains public & private */
                         | optional_stmt
                         | pointer_stmt
                         | target_stmt
                         | allocatable_stmt
			 | sequence_stmt   
			 | INCLUDE char_literal_constant
			     {  
			      /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
		              $$ = makeInclude(fi,$2);
				}
                         ;


implicit_stmt            : IMPLICIT implicit_spec 
                               {   
                                  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				PTR_LLND l;
             		     l = makeLlnd(fi, EXPR_LIST, $2, LLNULL, SMNULL);
		 	     $$ = makeImplicit(fi,IMPL_DECL,l);
			       }
			 | implicit_stmt  COMMA implicit_spec
                                 {  
				   /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 PTR_LLND l;
            		l = makeLlnd(fi, EXPR_LIST, $3, LLNULL, SMNULL);
			add_to_lowLevelList(l, $1->entry.implicit_decl.list);
				  }
                         | IMPLICIT NONE 
                              {  
			        /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			   $$ = makeImplicit(fi,IMPL_DECL,LLNULL);
			    }
                         ;


implicit_spec            : type_spec LEFTBRACKET2
                              letter_spec_list RIGHTBRACKET
                            { 
                             $$ = makeImpl_ll(fi,IMPL_TYPE,$1,$3);
			     }
                         ;

letter_spec_list         : letter_spec
			     {   $$ = set_ll_list($1, LLNULL, EXPR_LIST); }
                         | letter_spec_list COMMA letter_spec
                                { 
			$$ = set_ll_list($1, $3, EXPR_LIST);}
                         ;

letter_spec              : letter MINUS letter
                                { 
				PTR_LLND p,q;
  		         /*       setimpl(vartype, (int)$1, (int)$3);   */
              		p = makeLlnd(fi,CHAR_VAL, LLNULL, LLNULL, SMNULL);
              		p->entry.cval = $1; 
              		q = makeLlnd(fi,CHAR_VAL, LLNULL, LLNULL, SMNULL);
              		q->entry.cval = $3;  
              		$$= makeLlnd(fi,DDOT, p, q, SMNULL);}
                         | letter
			    {  
			/*       setimpl(vartype, (int)$1, (int)$1);   */
                            $$ = makeLlnd(fi,CHAR_VAL, LLNULL, LLNULL, SMNULL);
                            $$->entry.cval = $1;  
                            }
                         ;

letter:			 NAME
		        	{  $$=yytext[0];  }
			;

use_stmt                 : USE module_name COMMA rename_list 
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$=makeUse(fi,$2,LLNULL,$4);
				 } 
                         | USE module_name 
                                 { 
                                  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				  $$=makeUse(fi,$2,LLNULL,LLNULL);
				  }
                         | USE module_name COMMA ONLY COLON only_list 
                                 { 
                                  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeUse(fi,$2,$6,LLNULL);
            			}
                         | USE module_name COMMA ONLY COLON 
                                 { 
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeUse(fi,$2,LLNULL,LLNULL);
            			}
                         ;


module_name	  	 :name
			 ;

rename_list              : rename
				{ $$ = set_ll_list($1, LLNULL, EXPR_LIST); }
                         | rename_list COMMA rename
                                { 
				$$ = set_ll_list($1, $3, EXPR_LIST);}
                         ;

rename                   : name EQGT name
                                 { 
                                        }
                         ;
 
only_list                : only
			     { $$ = set_ll_list($1, LLNULL, EXPR_LIST); }
                         | only_list COMMA only
                                { 
                                 
				$$ = set_ll_list($1, $3, EXPR_LIST);}
                         ;
 
only                     : name EQGT name
                                 { 
                                   }
                         | name   { $$ = (PTR_LLND)$1; }          
/***		 	 | access_id          **** hitF90 ****/
                         ;

generic_spec:            name  { $$ = (PTR_LLND)$1; }
                         | OPERATOR LEFTBRACKET
                               defined_operator RIGHTBRACKET
                                { 
                                 }
                         | ASSIGNMENT
                              LEFTBRACKET EQUAL RIGHTBRACKET
                                { 
				 if(debugFlag_g==1) printf("assignment= \n");}
                         ;

defined_operator:         DEFINED_OPERATOR 
			    { }
                         | intrinsic_operator
                         ;

intrinsic_operator       : rel_op
			 | not_op
			 | or_op
			 | and_op
			 | equiv_op
			 | concat_op
			 | add_op
			 | mult_op
			 | power_op
			 ;

entry_stmt:		 ENTRY name arglist opt_result
			 	{    
                                  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeEntry(fi,$2,$3,$4);
				}
			 ;


interface_block          : interface_stmt cmnt
                                interface_body...
                                module_procedure_stmt...
                           end_interface_stmt 
			     {  $$ = makeMain_l($1,$3,$4,BFNULL,$5);
				$1->entry.interface.interface_end=$5;
				}
                         ;

interface_body...        :  { $$ = BFNULL; }
                         | interface_body... interface_body
			    { $$ = setBfndList($1,$2);  }
                         ;

module_procedure_stmt... :  { $$ = BFNULL; }
                         | module_procedure_stmt...
                                module_procedure_stmt cmnt
				{ $$ = setBfndList($1,$2);  }
                         ;

end_interface_stmt       : ENDINTERFACE 
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeEnd (fi); }
                         ;

interface_body           : function_stmt cmnt
                             specification...
                             end_function_stmt cmnt
                         | function_stmt cmnt
                             end_function_stmt cmnt
                         | subroutine_stmt cmnt
                             specification...
                             end_subroutine_stmt cmnt
                         | subroutine_stmt cmnt
                             end_subroutine_stmt cmnt
                         ;

module_procedure_stmt    : MODULE PROCEDURE 
                               procedure_name_list 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */
 				 $$ = makeVarlistdecl(fi,MODULE_PROC_STMT,$3);
				}
			 ;

procedure_name_list      : /*procedure_*/name {$$ = (PTR_LLND)$1; }
			 | procedure_name_list COMMA /*procedure_*/name
				{ 
				 }
			 ;
			 
interface_stmt           : INTERFACE generic_spec 
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$= makeInterface(fi,$2);
				 }
                         | INTERFACE 
                                { 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
 				 $$ = makeInterface(fi,SMNULL);
				 }
                         ;


parameter_stmt           : PARAMETER LEFTBRACKET named_constant_def_list
                               RIGHTBRACKET 
                                 { 
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$=makeVarlistdecl(fi,PARAM_DECL,$3);
				}
                         ;

named_constant_def_list  : named_constant_def
			     {  $$ = set_ll_list($1, LLNULL, EXPR_LIST); }
                         | named_constant_def_list COMMA
                                              named_constant_def
                                { 
				$$ = set_ll_list($1, $3, EXPR_LIST); }
                         ;

named_constant_def       : name EQUAL expr
                                { 
                                 }
                         ;


common_stmt              : COMMON  comblock  common_block_object  
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				PTR_LLND p, q;
        		        p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
              			q = makeLlnd(fi,COMM_LIST, p, LLNULL, $2);
            			$$ = makeNest(fi,COMM_STAT,$3,$2);
				}
                         | COMMON  common_block_object  
                                { 
                                 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */
				PTR_LLND p, q;
              			p = makeLlnd(fi,EXPR_LIST, $2, LLNULL, SMNULL);
              			q = makeLlnd(fi,COMM_LIST, p, LLNULL, SMNULL);
				$$ = makeNest(fi,COMM_STAT,$2,SMNULL); 
				}
			 | common_stmt opt_comma1 comblock opt_comma1 
				common_block_object
				 {  
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
				PTR_LLND p, q;
              			p = makeLlnd(fi,EXPR_LIST, $5, LLNULL, SMNULL);
              			q = makeLlnd(fi,COMM_LIST, p, LLNULL, $3);
				add_to_lowList(q, $1->entry.Template.ll_ptr1);}
			 | common_stmt COMMA common_block_object
				 {   
				 /*if(resultFlag_g==1)  strcat(pg[ln++],$$); */
				PTR_LLND p, q, r;
              			p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
              			q = makeLlnd(fi,COMM_LIST, p, LLNULL, SMNULL);
				for (r = $1->entry.Template.ll_ptr1;
                   		   r->entry.list.next;
                   		   r = r->entry.list.next);
              			add_to_lowLevelList(q, r->entry.Template.ll_ptr1);}
                         ;


comblock 		 : DIVIDE DIVIDE
				{   
				   }
			 | DIVIDE name DIVIDE
				{    
				  }
			 ;

opt_comma1		 : { }
			 | COMMA1 {  }
			 ;

common_block_object      : name LEFTBRACKET
                                 explicit_shape_spec_list RIGHTBRACKET
                                { 
				 $$ = makeObjectlist(fi,COMM_LIST,$3,$1);
				 }
                         | name
				{ $$ = makeObjectlist(fi,COMM_LIST,LLNULL,$1);
				}
                         ;

save_stmt                : SAVE opt_double_colon saved_entity_list 
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				$$=makeVarlistdecl(fi,SAVE_DECL,$3);
				}
                         | SAVE 
                                { 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				$$=makeVarlistdecl(fi,SAVE_DECL,LLNULL);
				}
                         ;

saved_entity_list        : saved_entity
				{$$ = makeLlnd(fi,EXPR_LIST, $1, LLNULL, SMNULL); }
                         | saved_entity_list  COMMA saved_entity
                                { 
				 $$ = set_ll_list($1, $3, EXPR_LIST);}
                         ;

saved_entity             : /*object_*/name  {  }
                         | DIVIDE /*common_block_*/name DIVIDE
                                { 
                                 }
                         ;


dimension_stmt           : DIMENSION opt_double_colon name dims
                                { 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 PTR_LLND l;
 				 /*  l=$3,$4;    ?  */
				 $$ = makeVarlistdecl(fi,DIM_STAT,l);
				 }
                         | dimension_stmt COMMA name dims
                                { 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 }
                         ;

dims:                     {   }
                         | LEFTBRACKET array_spec RIGHTBRACKET
                                { 
                                }
                         ;


equivalence_stmt         : EQUIVALENCE equivalence_set 
                                { 
                                 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */
				$$ = makeNest(fi,EQUI_STAT,$2, SMNULL);
				}
			 | equivalence_stmt COMMA equivalence_set
				{ 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 add_to_lowLevelList($3, $1->entry.Template.ll_ptr1);}
                         ;


equivalence_set          : LEFTBRACKET equivalence_object_list RIGHTBRACKET
                                { 
				 $$ = makeObjectlist(fi,EQUI_LIST, $2, SMNULL);}
                         ;

equivalence_object_list  : equivalence_object COMMA equivalence_object
				{ 
				PTR_LLND p;
       			       p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
              			$$ = makeLlnd(fi,EXPR_LIST, $1, p, SMNULL);}
                         | equivalence_object_list
                              COMMA equivalence_object
                                { 
				PTR_LLND p;
 		             p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
              			add_to_lowLevelList(p, $1);}
                         ;

equivalence_object       : name /* variable */ {  } 
                         | array_section_element_funcref/* array_element */
                         | substring
                         ;

external_stmt            : EXTERNAL name
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
 				 $$ = makeVarlistdecl(fi,EXTERN_STAT,$2);
				 }
			 | external_stmt  COMMA name
				{  
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 PTR_LLND p, q;
              			add_to_lowLevelList(q, $1->entry.Template.ll_ptr1);}
                         ;


intrinsic_stmt           : INTRINSIC name
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				PTR_LLND p, q;
				$$ = makeVarlistdecl(fi,INTRIN_STAT,$2);
				}
			 | intrinsic_stmt COMMA name
				{  
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
				PTR_LLND q;
              			add_to_lowLevelList(q, $1->entry.Template.ll_ptr1);}
                         ;


namelist_stmt:		  NAMELIST comblock /* DIVIDE name DIVIDE */ name
				{   
			         /*if(resultFlag_g==1)strcat(pg[ln++],$$); */
				 $$ = makeNest(fi,NAMELIST_STAT,$3,$2);}
			 | namelist_stmt COMMA name
				{   
/*  ? */			  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
				PTR_LLND p,q,r;
			        p = makeLlnd(fi,EXPR_LIST, $3, LLNULL, SMNULL);
                                q = makeLlnd(fi,COMM_LIST, p, LLNULL, SMNULL);
                                for (r = $1->entry.Template.ll_ptr1;
                                   r->entry.list.next;
                                   r = r->entry.list.next);
                                add_to_lowList(q, $1->entry.Template.ll_ptr1);}
			 | namelist_stmt opt_comma1 comblock name
				{     
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				PTR_LLND p, q;
                                p = makeLlnd(fi,EXPR_LIST, $4, LLNULL, SMNULL);
                                q = makeLlnd(fi,COMM_LIST, p, LLNULL, $3);
                                add_to_lowList(q, $1->entry.Template.ll_ptr1);}
			 ;


intent_stmt              : INTENT LEFTBRACKET intent_spec
                               RIGHTBRACKET opt_double_colon name
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeIntent(fi,$6,$3);
				 }
                         | intent_stmt COMMA name
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				PTR_LLND r;
              			add_to_lowLevelList(r, $1->entry.Template.ll_ptr1);}
                         ;

intent_spec              : IN    {  }
                         | OUT   {  }
                         | INOUT {  }
			 ;


access_stmt              : access_spec opt_double_colon access_id_list 
                                { 
                                 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeVarlistdecl(fi,$1,$3);
				}
                         | access_spec 
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeVarlistdecl(fi,$1,LLNULL);
				}
                         ;

access_id_list           : access_id
                         | access_id_list COMMA access_id
                                { 
                                 }
                         ;

access_id                : generic_spec
/*                       | use_name             */
                         ;

access_spec              : PUBLIC  { }
                         | PRIVATE { }
                         ;

optional_stmt            : OPTIONAL opt_double_colon  name
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				$$ = makeVarlistdecl(fi,OPTIONAL_STMT,$3);
				}
                         | optional_stmt COMMA name
                                { 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				PTR_LLND r;
              			add_to_lowLevelList(r, $1->entry.Template.ll_ptr1);}
                         ;

allocatable_stmt         :  ALLOCATABLE opt_double_colon name dims
                                { 
                                 /*if(resultFlag_g==1) strcpy(pg[ln++],$$); */
				 PTR_LLND l;
                                 /* l=$3,$4;   ?  */
                                 $$ = makeVarlistdecl(fi,ALLOCATABLE_STMT,l);
                                }
                         |  allocatable_stmt COMMA name dims
				{  
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ }
                         ;


pointer_stmt             : POINTER opt_double_colon name dims
                                { 
                                 /*if(resultFlag_g==1) strcpy(pg[ln++],$$); */
			         PTR_LLND l;
                                 /* l=$3,$4;    ?  */
                                 $$ = makeVarlistdecl(fi,POINTER_STMT,l);	
                                }
                         | pointer_stmt COMMA name dims
				{  
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ }
                         ;


target_stmt              : TARGET  opt_double_colon name dims
                                { 
                                 /*if(resultFlag_g==1) strcpy(pg[ln++],$$); */
				 PTR_LLND l;
                                 /*  l=$3,$4;    ?  */
                                 $$ = makeVarlistdecl(fi,TARGET_STMT,l);
                                }
                         | target_stmt COMMA name dims
                                {  
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ }
                         ;


derived_type_stmt        : TYPE COMMA access_spec opt_double_colon name 
                                { 
                                 /*if(resultFlag_g==1)  strcat(pg[ln++],$$); */
				 $$ = makeDerived(fi,$5,$3);}
                         | TYPE opt_double_colon name 
                                 { 
                                  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeDerived(fi,$3,LLNULL);}
                         ;
 

derived_type_def         : derived_type_stmt cmnt
                             private_sequence_stmt...
                             component_def_stmt cmnt
                             component_def_stmt...
			     end_type_stmt 
			   {
			      $$ = derivedDeal($1,$3,$4,$6);
			   }
			 ;

end_type_stmt 		 : ENDTYPE opt_name
				{  
				 /*if(resultFlag_g==1)  strcat(pg[ln++],$$); */
				$$ = makeEnd(fi);
				}
			 ;

private_sequence_stmt... :  {  } 
			 | private_sequence_stmt... private_sequence_stmt cmnt
			       {  $$ = setBfndList($1,$2);
				}
			 ;

private_sequence_stmt    : PRIVATE
				{   
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				  $$ = makeMiscell(fi,PRIVATE_STMT); }
			 | sequence_stmt
			 ;

component_def_stmt       : type_spec COMMA component_attr_spec_list
			      DOUBLECOLON component_decl_list 
				{ 
				 /*if(resultFlag_g==1)  strcat(pg[ln++],$$); */
				 $$ = makeTypedecl(fi,$5,$1,$3); 
				}
			 | type_spec opt_double_colon component_decl_list 
				{ 
				 
				 /*if(resultFlag_g==1)  strcat(pg[ln++],$$); */
				 $$ = makeTypedecl(fi,$3,$1,LLNULL);
				}
			 ;

component_def_stmt...    : { } 
			 | component_def_stmt... component_def_stmt  cmnt
			 ;

component_attr_spec_list : component_attr_spec 
			 | component_attr_spec_list COMMA component_attr_spec
				{ 
				 }
			 ;

component_decl_list      : component_decl  
			 | component_decl_list COMMA component_decl
				{ 
				 }
			 ;


component_attr_spec      : POINTER
				{ }
			 | DIMENSION LEFTBRACKET
				component_array_spec RIGHTBRACKET
				{ 
				 }
			 ;

component_array_spec     : array_spec
			 ;

component_decl           : name LEFTBRACKET
			      component_array_spec RIGHTBRACKET
				 MULTIPLY char_length
				{ 
				 
				 }
			 | name  { }
			 | name LEFTBRACKET
			      component_array_spec RIGHTBRACKET
				{ 
				 }
			 | name MULTIPLY char_length
				{ 
				 }
			 ;


sequence_stmt            : SEQUENCE
                                {  
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeMiscell(fi,SEQUENCE_STMT);}
			 ;


opt_double_colon:	  {   }
			 | DOUBLECOLON
				{  }
			 ;


/****************     Format_stmt    1995.8.23   **********************/

format_stmt              : /*_labelnu*/ FORMAT format_specification 
				{  
				 if(debugFlag_g==1) printf("format :%s\n",$$);
				 /*if(resultFlag_g==1) 	strcat(pg[ln++],$$); */}
			 ;

format_specification     : LEFTBRACKET format_item_list RIGHTBRACKET
				{  
				if(debugFlag_g==1)
					 printf("format_spec :%s\n",$$);}
			 | LEFTBRACKET RIGHTBRACKET
				 { }
			 ;

format_item_list         : format_item  
			 | format_item_list COMMA format_item
				{ 
				if(debugFlag_g==1) printf("format_item :%s\n",$$);}
			 ;

format_item              : r data_edit_desc
				{ }
                         | data_edit_desc
                         | control_edit_desc
                         | char_string_edit_desc
                         | r LEFTBRACKET format_item_list RIGHTBRACKET
				{ 
                                 }
                         | LEFTBRACKET format_item_list RIGHTBRACKET
				{ 
				 }
			 ;

r                        : digit_string
			 ;

data_edit_desc           : I real_literal_constant /* w FULLPOINT m */
				{ }
 			 | I w
				{ }
                         | B real_literal_constant /* w FULLPOINT m */
				{ }
			 | B w
				{ }
                         | O real_literal_constant /* w FULLPOINT m */
				{ }
			 | O w
				{ }
                         | Z real_literal_constant /* w FULLPOINT m */
				{ }
			 | Z w
				{ }
                         | F real_literal_constant /* w FULLPOINT d */
				{ }
			 | F w
				{ }
			 | E real_literal_constant /* w FULLPOINT d */
				{ }
                         | EN real_literal_constant /* w FULLPOINT d E e */
				{ }
                         | ES real_literal_constant /*w FULLPOINT d E e */
				{ }
                         | G real_literal_constant /*w FULLPOINT d E e*/
				{ }
                         | L w
				{ }
                         | A w
				{ }
                         | D real_literal_constant /*w FULLPOINT d*/
				{ }
			 | A{ }
			 ;

w                        : digit_string
			 ;

control_edit_desc        : position_edit_desc
                         | r DIVIDE{ }
			 | DIVIDE{ }
                         | COLON{ }
                         | sign_edit_desc
                         | k P{ }
                         | blank_interp_edit_desc
			 ;

k                        : digit_string
			 ;

position_edit_desc       : T n{ }
                         | TL n{ }
                         | TR n{ }
                         | n X{ }  
			 ;

n                        : digit_string
			 ;

sign_edit_desc           : S{ }
                         | SP{ }
                         | SS{ }
 			 ;

blank_interp_edit_desc   : BN{ }
                         | BZ{ }
			 ;

char_string_edit_desc    : STRING { }
                         | c H rep_char1
				{ 
				 }
 			 ;

rep_char1                : HCHAR { }
                         | rep_char1 HCHAR
				{ }
                         ;

c                        : digit_string
 			 ;


/**********   Type_declaration      95.8.22    ****************/

type_declaration_stmt    : type_spec newname1... DOUBLECOLON  
                                     entity_decl_list 
				 { 
				  if(debugFlag_g==1)printf("type:%s\n",$$);
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				  $$ = makeTypedecl(fi,$4,$1,$2);
                                  }
			 | type_spec opt_double_colon
				     entity_decl_list 
				  { 
				   if(debugFlag_g==1)printf("type: %s\n",$$);
			 	   /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
           			   $$ = makeTypedecl(fi,$3,$1,LLNULL);
                     	           }
			 ;
	
                            /* newname1... = [,attr_spec]...*/
newname1...		 : { }
			 | newname1... COMMA attr_spec
				{ 
                                 }
			 ;

entity_decl_list         : entity_decl
			 | entity_decl_list COMMA entity_decl
			 ;

type_spec                : INTEGER { 
				   strcpy(type_flag,"integer");
                                   row_num=linenum;
                                   }
			 | REAL { 
				 strcpy(type_flag,"real");
                                 row_num=linenum;
                                 }
			 | COMPLEX { 
				 strcpy(type_flag,"complex");row_num=linenum;
                                 }
                                 
			 | DOUBLEPRE { 
				 strcpy(type_flag,"dp");row_num=linenum;
                                 }
			 | CHARACTER { 
				 strcpy(type_flag,"character");row_num=linenum;
                                 }
			 | LOGICAL { 
				 strcpy(type_flag,"logical");row_num=linenum;
                                 }
			 | TYPE LEFTBRACKET /*type_*/name RIGHTBRACKET
				{ 
                                 
                                 strcpy(type_flag,"type");
                                 }
			 | REAL kind_selector
				 { 
				 strcpy(type_flag,"real");row_num=linenum;
                                 }
			 | COMPLEX kind_selector
				 {    
			         strcpy(type_flag,"complex");row_num=linenum;
                                 }
                         | CHARACTER char_selector
				 { 
			         strcpy(type_flag,"character");row_num=linenum;
				 if(debugFlag_g==1) printf("character:%s\n",$$);
                                 }
                         | LOGICAL kind_selector
				 { 
			         strcpy(type_flag,"logical");row_num=linenum;
                                 }
			 | INTEGER kind_selector      
				 { 
			         strcpy(type_flag,"integer");row_num=linenum;
                                 }
			 ;
 	
attr_spec                : PARAMETER { 
                                 strcpy(attr_flag,"parameter");} 
                         | DIMENSION LEFTBRACKET
                                array_spec RIGHTBRACKET
                                { 
				 
                                 strcpy(attr_flag,"dimension");}
                         | EXTERNAL { 
                                   strcpy(attr_flag,"external");
				   }	
                         | INTRINSIC { 
                                   strcpy(attr_flag,"intrinsic");
			 	   }
                         | SAVE { 
                                 strcpy(attr_flag,"save");} 
                         | OPTIONAL { 
                                  strcpy(attr_flag,"optional");}
                         | INTENT LEFTBRACKET
                                 intent_spec RIGHTBRACKET
				{ 
				   	
                               strcpy(attr_flag,"intent");}
                         | access_spec 
                         | POINTER { 
                                     strcpy(attr_flag,"pointer");
  				     }
                         | ALLOCATABLE { 
                                 strcpy(attr_flag,"allocatable");} 
                         | TARGET {  
                                   strcpy(attr_flag,"target");}  
			 ;
	
entity_decl              : name dims length /* contain "funcname" */
			      {  
				if(debugFlag_g==1) printf("entity:%s\n",$$); }
			 | name dims length EQUAL initialization_expr
			      { 
    			       
			       
				if(debugFlag_g==1) printf("entity:%s\n",$$); 
                               }
	/*		 | funcname dims length      */
			 ;

kind_selector            : LEFTBRACKET KINDEQ 
                           int_initialization_expr RIGHTBRACKET
				 { 
				  }
			 | LEFTBRACKET int_initialization_expr
                        	RIGHTBRACKET 
				 { 
                                  }
			 ;

int_initialization_expr  : expr
         	         ;	

char_selector            : length_selector  {if(debugFlag_g==1) 
						printf("char_ : %s\n",$$); }
                         | LEFTBRACKET LENEQ type_param_value
                            COMMA KINDEQ
                            int_initialization_expr RIGHTBRACKET
			  	 { 
				 
					}	
                         | LEFTBRACKET type_param_value   
                            COMMA KINDEQ 
                            int_initialization_expr RIGHTBRACKET
			  	 { 
				 
					}	
                         | LEFTBRACKET type_param_value COMMA
       	  		    int_initialization_expr RIGHTBRACKET
			  	 { 
				 
					}	
                         | LEFTBRACKET KINDEQ
                            int_initialization_expr COMMA
                            LENEQ type_param_value RIGHTBRACKET
			  	 { 
				 
				}	
			 | LEFTBRACKET KINDEQ 
                            int_initialization_expr RIGHTBRACKET
			  	 { 
					}	
			 ;


length_selector          : LEFTBRACKET LENEQ 
                               type_param_value RIGHTBRACKET
				{ 
				 }
/*                       | MULTIPLY char_length COMMA 
				{ 
				 }   */
			 | LEFTBRACKET type_param_value RIGHTBRACKET
				{ 
				 }
 			 | MULTIPLY char_length
				{ }
			 ;
	
length:                    {  }
			 | MULTIPLY char_length
				{   }
			 | char_length
			 ;
char_length              : LEFTBRACKET type_param_value RIGHTBRACKET
				{ 
				 }
			 | int_literal_constant
			 ;

type_param_value         : expr
			 | MULTIPLY
				{ }
			 ;

initialization_expr      : expr
			 ;


/***********    Data_stmt         95.8.22     ***********************/

data_stmt                : DATA data_stmt_list 
				{ 
				 /*if(resultFlag_g==1) 	strcat(pg[ln++],$$); */}
			 ;

data_stmt_list: 	 data_stmt_set
			 |data_stmt_list COMMA data_stmt_set
				{  }
			 |data_stmt_list data_stmt_set
				{    }
			 ;


data_stmt_set            : data_stmt_object_list  DIVIDE 
                               data_stmt_value_list DIVIDE
				{ 
				 }
			 ;


data_stmt_object_list    : data_stmt_object
			 | data_stmt_object_list COMMA data_stmt_object
				{ 
				 }
			 ;

data_stmt_object         : variable
                         | data_implied_do
			 ;

data_stmt_value_list     : data_stmt_value
			 | data_stmt_value_list COMMA data_stmt_value
				{ 
				 }
			 ;

data_stmt_value          : data_stmt_constant
			 | data_stmt_repeat MULTIPLY data_stmt_constant
				{ 
				 }
			 ;

data_stmt_constant       : constant
			 | signed_int_literal_constant
			 | signed_real_literal_constant      
/*			 | structure_constructor      */
			 ;

data_stmt_repeat         : constant
			 ;
 

data_implied_do		 : LEFTBRACKET data_i_do_object_list COMMA
                              data_i_do_variable EQUAL expr
                              COMMA expr RIGHTBRACKET
				{ 
				 }
		         | LEFTBRACKET data_i_do_object_list COMMA
                             data_i_do_variable EQUAL expr 
                              COMMA expr COMMA 
                                  expr RIGHTBRACKET
				{ 
				 }
			 ;

data_i_do_object_list    : data_i_do_object
			 | data_i_do_object_list data_i_do_object
				{ }
			 ;

data_i_do_object 	 : subobject1  
			 | data_implied_do
			 ;

data_i_do_variable	 : variable
			 ;



/******************** Grammmar for executable ****************************/
/********************   1995 . 8 . 25         ****************************/


opt_label:		 {  $$ = LBNULL; }
			 | label1
			 ;

executable:		  action_stmt
    		  	 | case_construct    
			 | do_construct  
			 | if_construct
                         | where_construct
                         ;
 
action_stmt:		 assignment_stmt      
				  /* contain "stmt_function_stmt" */
			 | assign_label_stmt   
			 | assign_goto_stmt   
			 | pointer_assignment_stmt
			 | allocate_stmt         
			 | nullify_stmt         
                         | associated_stmt     
			 | deallocate_stmt    
			 | call_stmt         
			 | return_stmt      
			  /*  control  operate  */
			 | goto_stmt       
			 | computed_goto_stmt   
			 | continue_stmt       
			 | stop_stmt          
			 | pause_stmt        
			 | exit_stmt        
			 | cycle_stmt      
			 | forall_stmt           /*  HPF */        
			 | if_stmt        
			 | arithmetic_if_stmt   
			 | where_stmt          
                          /*   I/O  File operate   */
			 | format_stmt    
			 | print_stmt
			 | read_stmt
			 | write_stmt
			 | open_stmt
			 | close_stmt
			 | inquire_stmt
			 | rewind_stmt
			 | backspace_stmt
			 | endfile_stmt
                	 ;

assignment_stmt:          variable EQUAL expr 
				{   
				  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				}
			 ;

/*
stmt_function_stmt       : name
                             LEFTBRACKET dummy_arg_name_list 
                             RIGHTBRACKET EQUAL expr 
			 | name LEFTBRACKET
                              RIGHTBRACKET EQUAL expr 
			 ;
*/

assign_label_stmt        : ASSIGN label TO variable 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

assign_goto_stmt	 : GOTO  name 
				{   
			 	 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | GOTO  name 
                                  COMMA LEFTBRACKET label_list
                                             RIGHTBRACKET 
			       {   
				/*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | GOTO  name LEFTBRACKET
                                  label_list RIGHTBRACKET
           			 {  
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

contains_stmt            : CONTAINS 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
				 $$ = makeMiscell(fi,CONTAINS_STMT);
				 setBlob($$,pred_bfnd);  }
			 ;

return_stmt              : RETURN expr 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | RETURN 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

call_stmt                : CALL name LEFTBRACKET
                                actual_arg_spec_list RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | CALL name 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | CALL name LEFTBRACKET RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

actual_arg_spec_list     : actual_arg_spec
			 | actual_arg_spec_list COMMA actual_arg_spec
				{ 
				 }
			 ; 

actual_arg_spec          : name  EQUAL actual_arg
				{ 
				 }
			 | actual_arg
			 ;

actual_arg               : expr       /* contain variable   */
               /*        | variable    */ 
               /*        | FUNNAME    */  
                         | MULTIPLY label 
				{ }
			 ;


allocate_stmt            : ALLOCATE LEFTBRACKET allocation_list
                                 COMMA STAT stat_variable
                                 RIGHTBRACKET
                                { 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
                                }
                         | ALLOCATE LEFTBRACKET allocation_list
                                 RIGHTBRACKET
                                { 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
                                }
                         ;

stat_variable            : variable
                         ;

allocation_list          : allocation
                         | allocation_list COMMA allocation
                                { 
                                 }
                         ;

allocation               : allocate_object LEFTBRACKET
                               allocate_shape_spec_list RIGHTBRACKET
                                { 
                                 }
                         | allocate_object
                         ;
 
allocate_shape_spec_list : allocate_shape_spec
                         | allocate_shape_spec_list
                                COMMA allocate_shape_spec
                                { 
                                 }
                         ;
 
allocate_object          : /*variable_*/name {}
                         | structure_component
                         ;

allocate_shape_spec      : allocate_lower_bound COLON
                                 allocate_upper_bound
                                { 
                                 }
                         | allocate_lower_bound /*allocate_upper_bound*/
                         ;

allocate_lower_bound     : expr
                         ;

allocate_upper_bound     : expr
                         ;


deallocate_stmt          : DEALLOCATE LEFTBRACKET allocate_object_list
                                 COMMA STAT stat_variable
                                 RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | DEALLOCATE LEFTBRACKET allocate_object_list
                                 RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;
 
allocate_object_list     : allocate_object
			 | allocate_object_list COMMA allocate_object
				{ 
				 }
			 ;

nullify_stmt             : NULLIFY LEFTBRACKET pointer_object_list
                                   RIGHTBRACKET 
				{ 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */   
                                 }
			 ;

pointer_object_list	 : pointer_object
			 | pointer_object_list COMMA pointer_object
				{ 
				 }
			 ;
	

associated_stmt          : ASSOCIATED LEFTBRACKET pointer_object
                                target_pointer RIGHTBRACKET 
				{ 
                                 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */ 
                                 }
                         ; 

target_pointer          : { } 
                         | COMMA  variable      
                               {  }
                         ;


pointer_assignment_stmt  : pointer_object EQGT variable  
                                {  
			       	  /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
                                 } 
			 ;

pointer_object:		  variable       
                         ;


exit_stmt                : EXIT name 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | EXIT 
				{ 
				/*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

stop_stmt                : STOP stop_code 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | STOP
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

stop_code                : char_constant
/*                       | label                */
			 ;

char_constant            : constant
			 ;

pause_stmt               : PAUSE stop_code 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
  			 | PAUSE 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

goto_stmt                : GOTO  label 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

computed_goto_stmt       : GOTO  LEFTBRACKET label_list 
                                RIGHTBRACKET COMMA expr 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | GOTO  LEFTBRACKET label_list
                                RIGHTBRACKET expr 
				{ 
			 	 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

label_list               : label {}
			 | label_list COMMA label
				{ 
				 } 
			 ;
                   
continue_stmt            : CONTINUE 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
		         ;

cycle_stmt               : CYCLE /*do_construct_*/name 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | CYCLE 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

/****************  Forall isn't contained in F90; It's in HPF  **************/

forall_stmt		 : FORALL LEFTBRACKET forall_control
		             RIGHTBRACKET forall_assignment 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

forall_control           : forall_script_control_list COMMA level_4_expr
				{ 
				 }
			 | forall_script_control_list
			 ;

forall_script_control_list : forall_script_control
			   | forall_script_control_list COMMA
				forall_script_control
				{ 
				 }
			   ;

forall_script_control  	 : name EQUAL expr COLON expr
				{ 
				 }
			 |  name EQUAL expr COLON expr COLON expr
				{ 
				  }
			 ;

forall_assignment:	  assignment_stmt
			 | pointer_assignment_stmt
			 ;

/**********************   Case_stmt  **********************************/ 


case_construct           : select_case_stmt cmnt
			      newname10...
                             end_select_stmt 
			 ;

                              /*newname10... = [case_stmt block]...*/
newname10...		 :
			 | newname10... case_stmt block
			 ;
		
select_case_stmt         : /*case_construct_*/name COLON SELECTCASE 
                                      LEFTBRACKET case_expr
                                      RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}     
			 | SELECTCASE LEFTBRACKET case_expr
                                              RIGHTBRACKET 
				{ 
				/*if(resultFlag_g==1) strcat(pg[ln++],$$); */}     
			 ;

case_stmt                : CASE case_selector /*case_construct_*/name cmnt 
				{ 
				/*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | CASE case_selector cmnt
				{ 
				/*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			        }
			 ;

block:                   executable...    
			 ;

end_select_stmt          : ENDSELECT /*case_construct_*/name 
				{/*if(resultFlag_g==1) strcpy(pg[ln++],"end caseif"); */}
			 | ENDSELECT 
				{/*if(resultFlag_g==1) strcpy(pg[ln++],"end caseif"); */}
			 ;

case_expr                : expr
			 ;


case_selector            : LEFTBRACKET case_value_range_list
                                RIGHTBRACKET 
				{ }
                         | DEFAULTL
				{ }
			 ;

case_value_range_list    : case_value_range
			 | case_value_range_list COMMA case_value_range
				{ 
				 }
			 ;

case_value_range         : case_value
                         | case_value COLON
				{ }
                         | COLON case_value
				{ }
                         | case_value COLON case_value
				{ 
				 }
			 ;

case_value               : int_initialization_expr
			 ;

logical_expr:		 expr
			 ;


/*******************    Do_stmt  **************************************/
		
do_construct             : block_do_construct
                         | nonblock_do_construct             
			 ;

block_do_construct       : nonlabel_do_stmt cmnt
                             /*do_block*/ executable...    
				end_do_stmt 
                         | label_do_stmt cmnt
                                executable...
                                  end_do_stmt
			 ;

end_do_stmt		 : ENDDO 
				{  }
			 | ENDDO name
				{  }
                         | continue_stmt
			 ;

label_do_stmt            : /*do_construct_*/name COLON
                                DO label loop_control 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			         }
			 | DO label 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			         }
			 | /*do_construct_*/name COLON DO label 
				{ 
				 /*if(resultFlag_g==1) 	strcat(pg[ln++],$$); */}
			 | DO label loop_control 
				{ 
				/*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

nonlabel_do_stmt         : /*do_construct_*/name COLON
                                 DO loop_control 
				{ 
				 
				/*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 | /*do_construct_*/name COLON DO 
				{ 
				/*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | DO 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */
			         }
			 | DO loop_control 
				{
				 /*if(resultFlag_g==1) strcpy(pg[ln++],$$); */
				 if (debugFlag_g==1) printf("Do %s\n",$$);
			         }
			 ;

loop_control             : COMMA do_variable EQUAL numeric_expr
                                 COMMA numeric_expr
                                   COMMA numeric_expr
				{ 
				 }   
			 | do_variable EQUAL numeric_expr COMMA
   			       numeric_expr
				{ 
				 }
			 | do_variable EQUAL numeric_expr COMMA
 			       numeric_expr COMMA
                                  numeric_expr
				{ 
				 }
			 | COMMA do_variable EQUAL numeric_expr
                                  COMMA numeric_expr
				{
				 }
                         | COMMA WHILE LEFTBRACKET
                                  logical_expr RIGHTBRACKET
				{ 
				 }
			 | WHILE LEFTBRACKET
                                  logical_expr RIGHTBRACKET
				{ 
				 }
			 ;

numeric_expr:            expr
			 ;

do_variable:             variable  
				{ if(debugFlag_g==1) printf("do_variable\n"); }
			 ;

nonblock_do_construct    : outer_shared_do_construct
			 ;

outer_shared_do_construct: label_do_stmt cmnt executable     /*do_body*/
			 | outer_shared_do_construct
			   label_do_stmt cmnt executable    
			 ;


/*********************   If_construct   95.8.25 ***************************/

if_construct             : if_then_stmt cmnt
                             block
			     newname11...
                           else_stmt cmnt
                              block
                           end_if_stmt 
			 | if_then_stmt cmnt
			     block
			     newname11...
                           end_if_stmt 
			 ;

                           /*newname11... = [else_if_stmt block]...*/
newname11...		 :
			 | newname11... else_if_stmt cmnt block
			 ;

if_then_stmt             : /*if_construct_*/name COLON
                              IF LEFTBRACKET logical_expr
                              RIGHTBRACKET THEN 
				{ 
				/*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 | IF LEFTBRACKET logical_expr
                              RIGHTBRACKET THEN 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

else_if_stmt             : ELSEIF LEFTBRACKET logical_expr
                                RIGHTBRACKET THEN
                                   /*if_construct_*/name 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | ELSEIF LEFTBRACKET logical_expr
                              RIGHTBRACKET THEN 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

else_stmt                : ELSE /*if_construct_*/name 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | ELSE 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */} 
			 ;

end_if_stmt              : ENDIF /*if_construct_*/name 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 | ENDIF 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

if_stmt                  : IF LEFTBRACKET logical_expr
                             RIGHTBRACKET action_stmt
				    { 
				     /*if(resultFlag_g==1) strcpy(pg[ln++],$$); */}
 			 ;


arithmetic_if_stmt       : IF LEFTBRACKET logical_expr  /* level_2_expr */
                             RIGHTBRACKET 
				label COMMA label COMMA label 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

/******************    Where_stmt  ****************************************/

where_construct          : where_construct_begin cmnt
                             assignment_stmt...
				end_where_stmt 
		          {
			  }
			 | where_construct_begin cmnt
			     assignment_stmt...
			    elsewhere_stmt cmnt
			     assignment_stmt...
			      end_where_stmt 		
		          {
			   }	
			 ;

assignment_stmt...	 : { }
			 | assignment_stmt... assignment_stmt cmnt
			 ;


mask_expr                : logical_expr
			 ;

elsewhere_stmt           : ELSEWHERE 
				{ 
				 /*if(resultFlag_g==1) strcpy(pg[ln++],$$); */
				 current_ln=ln;}
			 ;

end_where_stmt           : ENDWHERE 
				{   
				  /*if(resultFlag_g==1) strcpy(pg[ln++],$$); */ }
 			 ;
       
where_construct_begin	: WHERE LEFTBRACKET mask_expr RIGHTBRACKET
                                  {
                                  /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
                         ;


where_stmt              : WHERE LEFTBRACKET mask_expr RIGHTBRACKET 
			   	{ current_ln=ln;ln++; } 
				assignment_stmt 
				  {
                                  /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
                         ;

/************************ 95.8.25  ***************************************/


/********************    I/O File Operate  ********************************/

backspace_stmt           : BACKSPACE external_file_unit 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
                         | BACKSPACE LEFTBRACKET
                               position_spec_list RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;

external_file_unit       : expr
			 ;

position_spec_list	 : position_spec
			 | position_spec_list COMMA position_spec
				{ 
				 }
			 ;
position_spec            : UNIT external_file_unit
				{ }
			 | external_file_unit
                         | IOSTAT variable
				{ }
                         | ERR label   
				{ }
			 ;

rewind_stmt              : REWIND external_file_unit 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
                         | REWIND LEFTBRACKET  position_spec_list 
                                RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;

endfile_stmt             : ENDFILE external_file_unit 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
                         | ENDFILE LEFTBRACKET position_spec_list 
                             RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;


close_stmt               : CLOSE LEFTBRACKET close_spec_list  
                             RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1) strcat(pg[ln++],$$); */}
			 ;

close_spec_list		 : close_spec
			 | close_spec_list COMMA close_spec
				{ 
				 }
			 ;
 
close_spec               : UNIT external_file_unit    
				{ } 
			 | external_file_unit
                         | IOSTAT variable
				{ }
                         | ERR label
				{ }
                         | STATUS default_char_expr
				{ }
                         ;

	
inquire_stmt             : INQUIRE LEFTBRACKET inquire_spec_list
                                 RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 | INQUIRE LEFTBRACKET IOLENGTH 
                               variable RIGHTBRACKET 
                                    output_item_list 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;

inquire_spec_list	 : inquire_spec
			 | inquire_spec_list COMMA inquire_spec
				{ 
				 }
			 ;

inquire_spec             : external_file_unit   
			 | UNIT external_file_unit
     				{ }
			 | FILEI file_name_expr
     				{ }
			 | IOSTAT variable
     				{ }
			 | ERR label 
     				{ }
			 | EXIST variable
     				{ }
 			 | OPENED variable
     				{ }
			 | NUMBER variable
     				{ }
			 | NAMED variable
     				{ }
			 | NAMEI variable
     				{ }
			 | ACCESSL variable
     				{ }
			 | SEQUENTIAL variable
     				{ }
			 | DIRECT variable
     				{ }
			 | FORM variable
     				{ }
			 | FORMATTED variable
     				{ }
			 | UNFORMATTED variable
     				{ }
			 | RECL variable
     				{ }
			 | NEXTREC variable
     				{ }
			 | BLANK variable
     				{ }
			 | POSITION variable
     				{ }
			 | ACTION variable
     				{ }
			 | READ variable
     				{ }
			 | WRITE variable
     				{ }
			 | READWRITE variable
     				{ }
			 | DELIM variable
     				{ }
			 | PAD variable
     				{ }
  	 		 ;
		


open_stmt                : OPEN LEFTBRACKET connect_spec_list
                               RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;

connect_spec_list	 : connect_spec
			 | connect_spec_list COMMA connect_spec
				{ 
				 }
			 ;

connect_spec             : UNIT external_file_unit
     				{ }
			 | external_file_unit
                         | IOSTAT variable
     				{ }
                         | ERR label
     				{ }
                         | FILEI file_name_expr
     				{ }
                         | STATUS default_char_expr
     				{ }
                         | ACCESSL default_char_expr
     				{ }
                         | FORM default_char_expr
     				{ }
                         | RECL expr
     				{ }
                         | BLANK default_char_expr
     				{ }
                         | POSITION default_char_expr
     				{ }
                         | ACTION default_char_expr
     				{ }
                         | DELIM default_char_expr
     				{ }
                         | PAD default_char_expr
     				{ }
			 ;

file_name_expr           : expr
			 ;

default_char_expr	 : expr
			 ;

 
print_stmt               : PRINT format COMMA output_item_list
				{ 
				 if(debugFlag_g==1) printf("print: %s\n",$$);
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 | PRINT format 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;

format			 : STRING
/*				_singlequo rep_char1 SINGLEQUO 
                         	_doublequo rep_char1 DOUBLEQUO	
                                  default_char_expr 			*/
			 	{ }
			 | label {if(debugFlag_g==1) printf("print :%s\n",$$);}
			 | MULTIPLY { }
			 | variable    
			 ;

 		
output_item_list	 : output_item
			 | output_item_list COMMA output_item
			 ;

output_item              : expr    
                         | io_implied_do    
			 ;
	
read_stmt                : READ LEFTBRACKET io_control_spec_list
                            RIGHTBRACKET input_item_list 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */} 
			 | READ LEFTBRACKET io_control_spec_list
                           RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
                         | READ format COMMA input_item_list 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 | READ format 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;

input_item_list		 : input_item
			 | input_item_list COMMA input_item
				{ 
				 }
			 ;

input_item               : variable
                         | io_implied_do
			 ;

io_implied_do            : LEFTBRACKET io_implied_do_object_list COMMA
                                   io_implied_do_control RIGHTBRACKET
				{ 
				 }
			 ;

io_implied_do_object_list: io_implied_do_object
			 | io_implied_do_object_list
				COMMA  io_implied_do_object
				{ 
				 }
			 ;

io_implied_do_object     : expr /*  array_element  input_item  */
                         | io_implied_do
					/*output_item  */
			 ;

io_implied_do_control    : variable EQUAL numeric_expr COMMA
                             numeric_expr COMMA
                                 numeric_expr
				{ 
				  }
			 | variable EQUAL numeric_expr COMMA
			     numeric_expr	
				{ 
				  }
			 ;

write_stmt               : WRITE LEFTBRACKET io_control_spec_list
                           RIGHTBRACKET output_item_list 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 | WRITE LEFTBRACKET io_control_spec_list
                             RIGHTBRACKET 
				{ 
				 /*if(resultFlag_g==1)strcat(pg[ln++],$$); */}
			 ;

io_control_spec_list     : io_control_spec
			 | io_control_spec_list COMMA2 io_control_spec
				{ 
				 }
			 ;

io_control_spec          : UNIT io_unit
				{ }
 /*                      | io_unit			*/	
                         | NML /*namelist_group_*/name
				{ }
/*                       | namelist_group_name		*/
                         | FMT format
				{ }
                         | REC expr
				{ }
                         | IOSTAT variable
				{ }
                         | ERR label
				{ }
                         | END label
				{ }
                         | ADVANCE default_char_expr
				{ }
                         | SIZE variable
				{ }
                         | EOR label  
				{ }
                         | STRING  {  }
			 | label {}  			
			 | MULTIPLY { }
			 | variable    
			 ;



io_unit                  : MULTIPLY
				{ }
			 | expr
			 ;

/*			 | internal_file_unit			
			 | external_file_unit
*/
/*
internal_file_unit       : variable
			 ;
*/

/*********************        1995.8.22     *****************************/

/*********************   Array_spec 95.8.25  ****************************/

array_spec:               explicit_shape_spec_list
                         | assumed_shape_spec_list
                         | assumed_size_spec         
			 ;

assumed_shape_spec_list  : assumed_shape_spec
			 | assumed_shape_spec_list COMMA
			      assumed_shape_spec
				{ 
				 }
			 ;

assumed_shape_spec       : lower_bound COLON
				{ }
			 | COLON
				{ }
			 ;

assumed_size_spec        : explicit_shape_spec_list COMMA lower_bound 
                                     COLON MULTIPLY
				{ 
				 }
  			 | MULTIPLY
				{ }
			 | explicit_shape_spec_list COMMA MULTIPLY
				{ }
			 | lower_bound COLON MULTIPLY	
				{ }
			 ;


explicit_shape_spec_list : explicit_shape_spec
			 | explicit_shape_spec_list COMMA
				  explicit_shape_spec
				{ 
				 }
			 ;

explicit_shape_spec      : lower_bound COLON upper_bound
				{ 
				     }
			 | lower_bound /*upper_bound*/
			 ;

lower_bound              :expr 
			 ;

upper_bound              :expr
			 ;


/************************  EXPRESSION  ***********************************/

expr:                     expr  DEFINED_OPERATOR level_5_expr
				 { 
                                  if(debugFlag_g==1) printf("expr\n");
                                  }
 			 | level_5_expr
				 {if(debugFlag_g==1) printf("expr\n"); }
			 ;

level_5_expr             : level_5_expr equiv_op equiv_operand
				 { 
				  }
			 | equiv_operand 
				{if(debugFlag_g==1) printf("level_5_expr\n"); }
			 ;

equiv_op                 : EQV{ }
                         | NEQV{ }
			 ;
	
equiv_operand            : equiv_operand or_op or_operand
				 { 
				  }
			 | or_operand
			 ;

or_op                    : OR{ }
			 ;

or_operand               : or_operand and_op and_operand
				 { 
				  }
			 | and_operand
			 ;

and_op                   : AND{ }
			 ;

and_operand              : not_op level_4_expr
				 { }
			 | level_4_expr
			 | not_op associated_stmt
				  { }
			 | associated_stmt  {}
			 ;

not_op                   : NOT{ }
			 ;
	
level_4_expr             : level_3_expr rel_op level_3_expr
				 { 
				  if(debugFlag_g==1) printf("level_4_expr \n");  }
			 | level_3_expr  
				{if(debugFlag_g==1) printf("level_4_expr\n"); }
			 ;

rel_op                   : EQ{ }
                         | NE{ }
                         | LT{ }
                         | LE{ }
                         | GT{ }
                         | GE{ }
                         | EQ1 { }
                         | NE1 { }
                         | LT1 { }
                         | LE1 { }
                         | GT1 { }
                         | GE1 { }
                         ;

level_3_expr             : level_3_expr concat_op level_2_expr
				 { 
				  }
			 | level_2_expr 
				{if(debugFlag_g==1) printf("level_3_expr\n"); }
			 ;

concat_op                : CONCAT { }
			 ;

level_2_expr             : level_2_expr add_op add_operand
				 { }
			 | add_operand 
				{if(debugFlag_g==1) printf("level_2_expr\n"); }
 			 | add_op add_operand
				 { }
			 ;

add_op                   : PLUS{ }
                         | MINUS{ }
			 ;

add_operand              : add_operand mult_op mult_operand
				 { }
			 | mult_operand
			 ;

mult_op                  : MULTIPLY{ }
                         | DIVIDE{ }
			 ;

mult_operand		 : level_1_expr 
			 | mult_operand power_op level_1_expr
				 { }
			 ;

power_op                 : POWER{ }
			 ;

level_1_expr             : defined_operator primary  
			   { 
			    if(debugFlag_g==1) printf("level_1_expr 1\n"); }
			 | primary  
			   {
			    if(debugFlag_g==1) printf("level_1_expr 2\n");  }
			 ;


primary:                 literal_constant  
                 /*      | constant_subobject     */
                         | variable  
				{ if(debugFlag_g==1) printf("primary \n"); }
                         | array_constructor
                 /*      | structure_constructor    */
                         | function_reference 
                         | LEFTBRACKET expr RIGHTBRACKET
 				{ 
				 }
			 ;

/*
constant_subobject       : subobject   
 			 ;

structure_constructor    : type_name LEFTBRACKET 
                                    expr_list RIGHTBRACKET
                         ;

expr_list                : expr
                         | expr_list COMMA expr
			 ;
*/

array_constructor        : ACVALUE1 ac_value_list ACVALUE2
				{ 
				 }
			 ;

ac_value_list            : ac_value
 			 | ac_value_list COMMA ac_value 
				{ 
				 }
			 ;

ac_value                 : expr
                         | ac_implied_do
			 ;

ac_implied_do            : LEFTBRACKET1 ac_value_list COMMA 
                                 ac_implied_do_control RIGHTBRACKET
				{ 
				 }
			 ;

ac_implied_do_control    : variable EQUAL expr COMMA
                               expr COMMA expr 
				{ 
				 }
			 | variable EQUAL expr COMMA
        		       expr	
				{ 
				 }
			 ;


function_reference       : /*function_*/name LEFTBRACKET  
                                 RIGHTBRACKET  
			      {	 
			      if(debugFlag_g==1) printf("func_ref : %s\n",$$); }
			 |  FUNNAME  LEFTBRACKET RIGHTBRACKET
			      {  
                              if(debugFlag_g==1) printf("func_ref : %s\n",$$); }
			 | /*function_*/FUNNAME  LEFTBRACKET
                                 actual_arg_spec_list RIGHTBRACKET
			      {  
                              if(debugFlag_g==1) printf("func_ref : %s\n",$$); }
			 ;

		
/********************    Expression end   **********************************/

/************************  Variable   1995.8.25 *****************************/


variable:                 name 
			    {if(debugFlag_g==1) printf(" variable: %s\n",$$); }
			 | subobject1
			    {if(debugFlag_g==1) printf("subobject1: %s\n",$$);}
			 | substring
			    {if(debugFlag_g==1) printf("substring : %s\n",$$);}
			 ;

subobject1: 		 array_section_element_funcref 
/*                       | array_element       	*/	
                         | structure_component    	
			 ;


array_section_element_funcref: data_ref LEFTBRACKET
				substring_range RIGHTBRACKET
		      	  { 
			  if(debugFlag_g==1) printf("array_section: %s\n",$$); }
			 | data_ref
			  {
			  if(debugFlag_g==1) printf("array_section: %s\n",$$); }
			 ;

data_ref		 : name LEFTBRACKET
				section_subscript_list RIGHTBRACKET
				{ 
				 }
			 | structure_component LEFTBRACKET
				section_subscript_list RIGHTBRACKET
				{ 
				 }
			 ;

section_subscript_list   : section_subscript
			 | section_subscript_list 
                              COMMA section_subscript
				{ 
				 }
			 ;
  
section_subscript        : subscript_triplet       /* array_section */
			 | subscript               /* array_element */
			 | name  EQUAL actual_arg /*part of function_reference*/
				{ }
			 ;


subscript_triplet        : expr COLON expr COLON expr   
			      	{  
			       	    } 
			 | COLON expr COLON expr
				{ 
				 }
			 | COLON COLON expr  
				{ }
			 | expr  COLON COLON expr
				{ }
			 | DOUBLECOLON expr 
				{ }
			 | expr DOUBLECOLON expr
				{ }
			 | substring_range
			 ;

substring_range          : expr COLON expr 
				{ 
				 }
 			 | COLON expr
				{ }
			 | expr COLON
				{ }
	                 | COLON{ }
			 ;


substring:  		 name LEFTBRACKET
                              substring_range RIGHTBRACKET
				{ 
				 }
			 | structure_component LEFTBRACKET
                              substring_range RIGHTBRACKET
				{ 
				 }
			 | array_section_element_funcref/* array_element */ LEFTBRACKET
                              substring_range RIGHTBRACKET
				{ 
				 }
			 | char_literal_constant LEFTBRACKET
                              substring_range RIGHTBRACKET
				{ 
				 }
			 ;		 

subscript:               expr
			 ;


structure_component:	 part_ref newname3
				{  
                                 }
			 ;

newname3		 : PERCENT part_ref
				{ }
			 | newname3 PERCENT part_ref
				{ 
				 }
			 ;
part_ref		 : name {}
			 | name LEFTBRACKET section_subscript_list
                 			RIGHTBRACKET 
				{ 
				 }
			 ;


/*
stride                   : expr
			 ;
*/

/************************    8.25 *******************************************/

/************************   Constant     1995.8.24  *************************/

constant:                 literal_constant
                         | name {}
			 ;

literal_constant:         int_literal_constant
			  {
		        if(debugFlag_g==1) printf("int_literal_const: %s\n",$$);
			   }
                         | real_literal_constant
                         | complex_literal_constant
                         | logical_literal_constant
                         | char_literal_constant
                         | boz_literal_constant     
			 | double_literal_constant  
			 ;

real_literal_constant:   REAL_LITERAL_CONST
			 { 
			if(debugFlag_g==1) printf("real_literal_const:%s\n",$$);
			 }
			 ;

double_literal_constant: DOUBLE_LITERAL_CONST
			 {
		      if(debugFlag_g==1) printf("double_literal_const:%s\n",$$);
			 }
			 ;

boz_literal_constant     : BINARY_CONST  { }
                         | OCTAL_CONST   { }
                         | HEX_CONST  { }
			 ;

char_literal_constant    : kind_param UNDERSCORE1 STRING
				{ }
                         | STRING { }
			 ;

signed_real_literal_constant : PLUS real_literal_constant
			 	{ }
			     | MINUS real_literal_constant
				{ }
/*			     | real_literal_constant              */
			     ;

signed_int_literal_constant : PLUS int_literal_constant
 		 	      { 
			      if(debugFlag_g==1) printf("signed_const:%s\n",$$);
				}
			    | MINUS int_literal_constant
			      { 
			      if(debugFlag_g==1) printf("signed_const:%s\n",$$);
				}
/*			    | int_literal_constant		 */
			    ;


int_literal_constant     : digit_string UNDERSCORE kind_param
                                { 
                                 }
                         | digit_string
                         ;

/*
real_literal_constant    : significand NAME signed_digit_string 
                               	 UNDERSCORE kind_param 
				{ 
				 }
			 | significand
			 | significand NAME signed_digit_string
				{ 
				 }
			 | significand UNDERSCORE kind_param
				{ 
				 }
                         | digit_string NAME signed_digit_string
                                 UNDERSCORE kind_param 
				{ 
				 }
			 | digit_string NAME signed_digit_string
				{ 
				 }
			 ;
significand              : digit_string FULLPOINT digit_string 
				{ 
				 }
                         | FULLPOINT digit_string  
				{ }  
			 | digit_string FULLPOINT
				{ }
			 ;


signed_digit_string      : PLUS digit_string
				{ }
			 | MINUS digit_string
				{  }
			 | digit_string
			 ;

*/

complex_literal_constant : LEFTBRACKET real_part
                              COMMA image_part RIGHTBRACKET  
			   {   
			   if(debugFlag_g==1) printf("complex_const:%s\n",$$);} 
			 ;

/*
real_part:		  level_2_expr
			 ;
image_part:		  level_2_expr
			 ;
*/

real_part                : signed_int_literal_constant
                         | signed_real_literal_constant
			 ;
image_part               : signed_int_literal_constant
                         | signed_real_literal_constant
			 ;


logical_literal_constant : TRUEL { }  
                         | FALSEL { }  
			 | TRUEL UNDERSCORE kind_param
				{ }
			 | FALSEL UNDERSCORE kind_param
				{ }
			 ;


/*********************************************************************/

/*********************   95.8.23  ************************************/

digit_string:		 DIGIT_STRING
				{ }
			 ;

kind_param               : digit_string
                         | name  /*int_constant_*/
				{ }
                         ;

label1:			  LABEL 
				{ }
			 ;

label:			 digit_string 
				{ }
			 ;


/**********************    THE END    *********************************/

specification
    :  hpf_spec_directives
    ;

executable
    :  hpf_exec_directives
    |  forall_construct
    ;

hpf_spec_directives
    :  processors_directive
    |  align_directive
    |  distribute_directive
    |  dynamic_directive
    |  inherit_directive
    |  template_directive
    |  combined_directive
    |  sequence_directive
    ;

hpf_exec_directives
    :  realign_directive
    |  redistribute_directive
    |  independent_directive
    ;

combined_directive
    :  combined_attribute_list  DOUBLECOLON  entity_decl_list
		{ }
    ;

combined_attribute_list
    :  combined_attribute
    |  combined_attribute_list COMMA combined_attribute
    ;

combined_attribute
    :  ALIGN align_attribute_stuff  {}
    |  DISTRIBUTE dist_attribute_stuff  {}
    |  DYNAMIC  {} 
    |  INHERIT  {} 
    |  TEMPLATE  {}
    |  PROCESSORS  {}
    |  DIRDIMENSION LEFTBRACKET explicit_shape_spec_list 
       RIGHTBRACKET   {}
    ;

distribute_directive
    :  DISTRIBUTE distributee dist_directive_stuff
		{}
    ;

redistribute_directive
    :  REDISTRIBUTE distributee dist_directive_stuff
		{}
    |  REDISTRIBUTE dist_attribute_stuff DOUBLECOLON 
       distributee_list
		{}
    ;

dist_directive_stuff
    :  dist_format_clause
    |  dist_format_clause dist_onto_clause
    ;

dist_attribute_stuff
    :  dist_directive_stuff
    |  dist_onto_clause
    ;

distributee_list
    :  distributee
    |  distributee_list COMMA distributee
    ;

distributee
    :  name
	{}
    ;

dist_format_clause
    :  LEFTBRACKET dist_format_list  RIGHTBRACKET {}
    |  MULTIPLY LEFTBRACKET dist_format_list  RIGHTBRACKET {}
    |  MULTIPLY  {}
    ;

dist_format_list
    :  dist_format
    |  dist_format_list COMMA dist_format
    ;

dist_format
    :  BLOCK      {}
    |  CYCLIC     {}
    |  MULTIPLY   {}
    |  BLOCK LEFTBRACKET expr RIGHTBRACKET  {}
    |  CYCLIC LEFTBRACKET expr RIGHTBRACKET   {}
    ;

dist_onto_clause
    :  ONTO dist_target {}
    ;

dist_target
    :  processors_name
    |  MULTIPLY processors_name  {}
    |  MULTIPLY  {}
    ;

processors_name
    :  name  {}
    ;

align_directive
    :  ALIGN alignee align_directive_stuff
		{}
    ;

realign_directive
    :  REALIGN alignee align_directive_stuff
		{}
    |  REALIGN align_attribute_stuff DOUBLECOLON alignee_list
		{}
    ;

align_directive_stuff
    :  LEFTBRACKET align_source_list RIGHTBRACKET 
       align_with_clause   {}
    ;

align_attribute_stuff
    :  align_with_clause
    |  LEFTBRACKET align_source_list RIGHTBRACKET 
       align_with_clause  {}
    ;

alignee_list
    :  alignee
    |  alignee_list COMMA alignee
    ;

alignee
    :  name  {}
    ;

align_source_list
    :  align_source
    |  align_source_list COMMA  align_source
    ;

align_source
    :  COLON  {}
    |  MULTIPLY {}
    |  align_dummy
    ;

align_dummy
    :  variable
    ;

align_with_clause
    :  WITH align_spec   {}
    ;

align_spec
    :  align_target
    |  align_target LEFTBRACKET align_subscript_list 
       RIGHTBRACKET
    |  MULTIPLY align_target   {}
    |  MULTIPLY align_target LEFTBRACKET align_subscript_list 
       RIGHTBRACKET
		{}
    ;

align_target
    :  name  {}
    ;

align_subscript_list
    :  align_subscript
    |  align_subscript_list COMMA  align_subscript 
    ;

align_subscript
    :  expr
/*  | align_subscript_use    */
    |  subscript_triplet
    |  MULTIPLY  {}
    ;

/*
align_subscript_use
    :  align_subscript_use:
       
*/
       
dynamic_directive
    :  DYNAMIC alignee_distributee_list
	    {}
    ;

alignee_distributee_list
    :  alignee_distributee
    |  alignee_distributee_list COMMA alignee_distributee
    ;

alignee_distributee
    :  name  {}
    ;
/*  |  alignee
    |  distributee
*/		
       
processors_directive
    :  PROCESSORS processors_decl_list
		{}
    ;

processors_decl_list
    :  processors_decl
    |  processors_decl_list COMMA processors_decl
    ;

processors_decl
    :  processors_name
    |  processors_name LEFTBRACKET explicit_shape_spec_list
       RIGHTBRACKET  {}
    ;

template_directive
    :  TEMPLATE template_decl_list
		{}
    ;

template_decl_list
    :  template_decl
    |  template_decl_list COMMA template_decl
    ;

template_decl
    :  template_name
    |  template_name LEFTBRACKET explicit_shape_spec_list 
       RIGHTBRACKET   
    ;

template_name
    :  name  {}
    ;

inherit_directive
    :  INHERIT dummy_args
		{}
    ;

sequence_directive
    :  DIRSEQUENCE   {}
    |  NO DIRSEQUENCE   {}
    |  DIRSEQUENCE opt_double_colon association_name_list  {}
    |  NO SEQUENCE opt_double_colon association_name_list  {}
    ;

association_name_list
    :  association_name
    |  association_name_list COMMA association_name
    ;

association_name
    :  name   {}
    |  DIVIDE /* common_block_ */ name DIVIDE  {}
    ;

independent_directive
    :  INDEPENDENT  {} 
    |  INDEPENDENT COMMA new_clause
		{}
    ;

new_clause
    :  NEW LEFTBRACKET variable_list RIGHTBRACKET
		{}
    ;

variable_list
    :  variable
    |  variable_list COMMA variable
    ;

forall_construct
    :  forall_construct_begin cmnt
       forall_body...
       END FORALL 
    ;

forall_construct_begin
    :  FORALL LEFTBRACKET forall_control
       RIGHTBRACKET  
		{}
    ;

forall_body...  	
    :   {}
    |  forall_body... forall_body cmnt
    ;

forall_body
    :  forall_assignment
    |  where_stmt
    |  forall_stmt
    |  where_construct
    |  forall_construct
    ;

/*************    Prefix   ********************/
       
extrinsic_prefix
    :  EXTRINSIC  LEFTBRACKET extrinsic_kind_keyword
       RIGHTBRACKET
		{}
    ;

extrinsic_kind_keyword
    :  HPF   {}
    |  HPF_LOCAL  {}
    ;

prefix
    :  PURE  {}
    |  extrinsic_prefix
    |  RECURSIVE  {}
    |  type_spec  {}
    ;


%%
yyerror(str)
char *str;
{
  lxyError_m(yychar);
  printf("\nline(%d) syntax error:%d  %s\n",linenum,yychar,lxyStr_g);
  globeErr_g=1;
  throw_away();	
  yyerrok;
  yyclearin; 
} 

/***   lxyError_m(int a)   ***/
lxyError_m(a)
int a;
{
  FILE *fp1;
  int a1,i,j;
  char  ch;
  fp1=fopen("error.h","r");
  if(fp1==NULL)
    {  printf("\nerror file can't be open!\n");
       exit(0);
     }
  else
   {  a1=a-257;
      for(i=0;i<=a1;i++)
        { j=0;
          while((ch=getc(fp1))!=0x0a)
            {
              lxyStr_g[j]=ch;
              j++;
             }
          lxyStr_g[j]='\0';
         }
       fclose(fp1);
      }
}

throw_away()
{
   while(yytext[0]!='\n')
        yylex();
}

